//
// PropertyGreenVerification.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PropertyGreenVerification: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var greenBuildingVerificationKeyNumeric: Double?
    public var greenVerificationMetric: Double?
    public var greenVerificationYear: Double?
    public var listingKeyNumeric: Double?
    public var greenBuildingVerificationKey: String?
    public var greenVerificationBody: String?
    public var greenVerificationRating: String?
    public var greenVerificationURL: String?
    public var greenVerificationVersion: String?
    public var listingId: String?
    public var listingKey: String?
    public var greenBuildingVerificationType: String?
    public var greenVerificationSource: String?
    public var greenVerificationStatus: String?
    public var modificationTimestamp: Date?
    public var property: Property?

    public init(id: Int? = nil, greenBuildingVerificationKeyNumeric: Double? = nil, greenVerificationMetric: Double? = nil, greenVerificationYear: Double? = nil, listingKeyNumeric: Double? = nil, greenBuildingVerificationKey: String? = nil, greenVerificationBody: String? = nil, greenVerificationRating: String? = nil, greenVerificationURL: String? = nil, greenVerificationVersion: String? = nil, listingId: String? = nil, listingKey: String? = nil, greenBuildingVerificationType: String? = nil, greenVerificationSource: String? = nil, greenVerificationStatus: String? = nil, modificationTimestamp: Date? = nil, property: Property? = nil) {
        self.id = id
        self.greenBuildingVerificationKeyNumeric = greenBuildingVerificationKeyNumeric
        self.greenVerificationMetric = greenVerificationMetric
        self.greenVerificationYear = greenVerificationYear
        self.listingKeyNumeric = listingKeyNumeric
        self.greenBuildingVerificationKey = greenBuildingVerificationKey
        self.greenVerificationBody = greenVerificationBody
        self.greenVerificationRating = greenVerificationRating
        self.greenVerificationURL = greenVerificationURL
        self.greenVerificationVersion = greenVerificationVersion
        self.listingId = listingId
        self.listingKey = listingKey
        self.greenBuildingVerificationType = greenBuildingVerificationType
        self.greenVerificationSource = greenVerificationSource
        self.greenVerificationStatus = greenVerificationStatus
        self.modificationTimestamp = modificationTimestamp
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case greenBuildingVerificationKeyNumeric = "GreenBuildingVerificationKeyNumeric"
        case greenVerificationMetric = "GreenVerificationMetric"
        case greenVerificationYear = "GreenVerificationYear"
        case listingKeyNumeric = "ListingKeyNumeric"
        case greenBuildingVerificationKey = "GreenBuildingVerificationKey"
        case greenVerificationBody = "GreenVerificationBody"
        case greenVerificationRating = "GreenVerificationRating"
        case greenVerificationURL = "GreenVerificationURL"
        case greenVerificationVersion = "GreenVerificationVersion"
        case listingId = "ListingId"
        case listingKey = "ListingKey"
        case greenBuildingVerificationType = "GreenBuildingVerificationType"
        case greenVerificationSource = "GreenVerificationSource"
        case greenVerificationStatus = "GreenVerificationStatus"
        case modificationTimestamp = "ModificationTimestamp"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(greenBuildingVerificationKeyNumeric, forKey: .greenBuildingVerificationKeyNumeric)
        try container.encodeIfPresent(greenVerificationMetric, forKey: .greenVerificationMetric)
        try container.encodeIfPresent(greenVerificationYear, forKey: .greenVerificationYear)
        try container.encodeIfPresent(listingKeyNumeric, forKey: .listingKeyNumeric)
        try container.encodeIfPresent(greenBuildingVerificationKey, forKey: .greenBuildingVerificationKey)
        try container.encodeIfPresent(greenVerificationBody, forKey: .greenVerificationBody)
        try container.encodeIfPresent(greenVerificationRating, forKey: .greenVerificationRating)
        try container.encodeIfPresent(greenVerificationURL, forKey: .greenVerificationURL)
        try container.encodeIfPresent(greenVerificationVersion, forKey: .greenVerificationVersion)
        try container.encodeIfPresent(listingId, forKey: .listingId)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(greenBuildingVerificationType, forKey: .greenBuildingVerificationType)
        try container.encodeIfPresent(greenVerificationSource, forKey: .greenVerificationSource)
        try container.encodeIfPresent(greenVerificationStatus, forKey: .greenVerificationStatus)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

